package eu.dnetlib.uoamonitorservice.dao;

import eu.dnetlib.uoamonitorservice.entities.Stakeholder;
import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface StakeholderDAO extends MongoRepository<Stakeholder, String> {
    List<Stakeholder> findAll();
    List<Stakeholder> findByType(String Type);

    List<Stakeholder> findByDefaultIdIsNull();
    List<Stakeholder> findByDefaultIdAndCopyTrue(String defaultId);
    List<Stakeholder> findByDefaultIdAndType(String DefaultId, String Type);

    List<Stakeholder> findByDefaultIdIsNotNull();
    List<Stakeholder> findByDefaultIdIsNotNullAndType(String Type);

    List<Stakeholder> findByTopicsContaining(String topic);

    Optional<Stakeholder> findById(String Id);
    Optional<Stakeholder> findByAlias(String Alias);

    void delete(String Id);

    Stakeholder save(Stakeholder stakeholder);
}
