package eu.dnetlib.uoamonitorservice.generics;

import com.fasterxml.jackson.annotation.JsonProperty;
import eu.dnetlib.uoamonitorservice.entities.Category;
import eu.dnetlib.uoamonitorservice.primitives.Visibility;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Document
public class CategoryGeneric<StringOrSubcategory> extends Common {
    protected boolean isOverview;
    protected List<StringOrSubcategory> subCategories;

    public CategoryGeneric() {}

    public CategoryGeneric(CategoryGeneric category) {
        id = category.getId();
        name = category.getName();
        alias = category.getAlias();
        description = category.getDescription();
        setVisibility(category.getVisibility());
        creationDate = category.getCreationDate();
        updateDate = category.getUpdateDate();
        defaultId = category.getDefaultId();
        isOverview = category.getIsOverview();
        subCategories = new ArrayList<>();
    }

    public boolean getIsOverview() {
        return isOverview;
    }

    public void setIsOverview(boolean isOverview) {
        this.isOverview = isOverview;
    }

    public List<StringOrSubcategory> getSubCategories() {
        return subCategories;
    }

    public void setSubCategories(List<StringOrSubcategory> subCategories) {
        this.subCategories = subCategories;
    }
}
